#define CIRCLEPOS2(p,d,r) CIRCLEPOS((p select 0), (p select 1), d, r)
#define CIRCLEPOS(x,y,d,r) [x+r*sin(d),y+r*cos(d)]

#define MISSILE "jdg_rim7"

TeTeT_camActive = false;

TeTeT_fireMissile = {
  private ["_launcher", "_pos", "_dir", "_missile"];
  _launcher = _this select 0;
  _pos = getPosASL _launcher;
  _pos = [_pos select 0, _pos select 1, (_pos select 2) + 3.3];
  _dir = getDir _launcher - ((_launcher animationPhase "Turret") * 180) / pi;
  _missile = createVehicle [MISSILE, _pos, [], 0, "CAN_COLLIDE"];
  _missile setPosASL _pos;
  _missile setDir _dir;
  [_missile, 45, 0] call BIS_fnc_setPitchBank;
  _missile;
};

TeTeT_trackTarget = {
  private ["_missile", "_tgt"];
  _missile = _this select 0;
  _tgt = _this select 1;

  // setup proximity fuse and self destruct
  [_missile, _tgt] spawn {
    private ["_missile", "_tgt"];
    _missile = _this select 0;
    _tgt = _this select 1;
    waitUntil {_missile distance _tgt < 100};
    while {alive _missile && alive _tgt} do {
      // proximity fuse
      if (_missile distance _tgt < 20) then {
        "HelicopterExploSmall" createVehicle getPos _missile;
        _missile setDamage 1;
      };
      // auto destruct
      if (_missile distance _tgt > 100) then {
        _missile setDamage 1;
        player sideChat "Weapon auto destructed";
      };
      sleep 0.01;
    };
  };

  while { alive _missile && alive _tgt } do {
    private ["_turn", "_dir", "_currDir", "_altMissile", "_altTarget", "_altDiff"];
    _dir = [_missile, _tgt] call BIS_fnc_dirTo;
    _relDir = [_missile, _tgt] call BIS_fnc_relativeDirTo;
    _turn = 0;
    if (_relDir < 180) then {
      _turn = 1;
    } else {
      _turn = -1;
    };
    // not sure if 5 is a sensible default here, could as well be lower
    while { getDir _missile - _dir > 5 or getDir _missile - _dir < -5} do {
      _missile setDir ((getDir _missile) + _turn);
      sleep 0.01;
    };

    _missile setDir _dir;
    sleep 0.05;
    _altMissile = getPosASL _missile select 2;
    _altTarget = getPosASL _missile select 2;
    _altDiff = _altMissile - _altTarget;
    // This is quite a hack, the missile tends to drop to the water, so I simply keep it at altitude :(
    if (_altDiff < 10) then {
      _missile setPosASL [getPos _missile select 0, getPos _missile select 1, getPosASL _tgt select 2];
    } else {
      if (_altMissile < _altTarget) then {
        [_missile, 30, 0] call BIS_fnc_setPitchBank;
      } else {
        [_missile, -5, 0] call BIS_fnc_setPitchBank;
      };
    };
    sleep 0.05;
  };

  _missile setDamage 1;
};

TeTeT_cam = {
  waitUntil {!TeTeT_camActive};
  TeTeT_camActive = true;
  private ["_missile", "_camera", "_pos"];
  _missile = _this select 0;
  _pos = getPos _missile;
  _camera = "camera" camCreate _pos;

  while {alive _missile && alive _camera} do {
    _camera camSetTarget _missile;
    _camera camsetRelPos [0, -10, 0.5];
    _camera cameraEffect ["internal", "back"];
    _camera camSetFOV 0.7;
    _camera camCommit 0;
    sleep 0.001;
  };
  sleep 5;
  _camera cameraEffect ["terminate", "back"];
  camDestroy _camera;
  TeTeT_camActive = false;
};

TeTeT_turnLauncher = {
  private ["_launcher", "_tgt", "_dir"];
  _launcher = _this select 0;
  _tgt = _this select 1;
  _dir = [_launcher, _tgt] call BIS_fnc_dirTo;
  _dir = (getDir _launcher - _dir) / 100;
  _launcher animate ["Gun", 0];
  waitUntil {_launcher animationPhase "Gun" < 0.1};
  _launcher animate ["Turret", _dir];
  waitUntil { _launcher animationPhase "Turret" == _dir} ;
  sleep 2;
  _launcher animate ["Gun", 0.7];
  waitUntil {_launcher animationPhase "Gun" > 0.6};
};

TeTeT_selectTarget = {
  private ["_pos", "_launcher", "_tgt", "_list", "_missile"];
  _pos = _this select 0;
  _launcher = _this select 1;

  _list = nearestObjects [_pos, ["Air"], 1000];
  if (isNil "_list" or count _list == 0) exitWith {};
  _tgt = _list select 0;
  player sideChat format ["Target is %1", _tgt];
  sleep 2;
  [_launcher, _tgt] call TeTeT_turnLauncher;
  if (terrainIntersectASL [getPosASL _launcher, getPosASL _tgt]) exitWith {
    player sideChat "No Line of Sight to the target, aborting";
  };
  _missile = [_launcher] call TeTeT_fireMissile;
  sleep 0.5;
  [_missile, _tgt] spawn TeTeT_trackTarget;
  sleep 0.5;
  [_missile] spawn TeTeT_cam;
  true
};

TeTeT_seasparrow = {
  player sideChat "Opening sea sparrow controls";
  openMap true;
  onMapSingleClick "[_pos, S] spawn TeTeT_selectTarget; onMapSingleClick ''; openMap false; true";
};

TeTeT_markMe = {
  private ["_obj", "_m"];
  _obj = _this select 0;
  _m = createMarker [_obj getVariable "TeTeT_marker", position _obj];
  _m setMarkerText (_obj getVariable "TeTeT_marker");
  _m setMarkerType "mil_dot";
  _m setMarkerColor "ColorRed";
  while { alive _obj } do {
    _m setMarkerPos (position _obj);
    sleep 0.5;
  };
  _m setMarkerColor "ColorBlack";
};

TeTeT_markEnemies = {
  private ["_list", "_i"];
  _list = position player nearObjects ["Air", 20000];
  _i = 0;
  {
    _x setVariable ["TeTeT_marker", format["Bogey %1", _i], true];
    [_x] spawn TeTeT_markMe;
    _i = _i + 1;
  } forEach _list;
};

waitUntil {alive player};

[] call TeTeT_markEnemies;
player addAction ["Sea Sparrow", TeTeT_seasparrow];

/*[] spawn {
 private ["_shots"];
 _shots = 8;
 while {alive S and alive Target and _shots > 0} do {
  private ["_dir", "_missile"];
  _dir = [S, Target] call BIS_fnc_dirTo;
  _dir = (getDir S - _dir) / 100;
  S animate ["Turret", _dir];
  sleep 5;
  S animate ["Gun", 0];
  waitUntil {S animationPhase "Gun" < 0.1};
  sleep 2;
  S animate ["Gun", 0.7];
  waitUntil {S animationPhase "Gun" > 0.6};
  _missile = [S] call TeTeT_fireMissile;
  sleep 0.5;
  [_missile, Target] spawn TeTeT_trackTarget;
  sleep 0.5;
  [_missile] spawn TeTeT_cam;
  sleep 10;
  _shots = _shots - 1;
};
*/
/* while {alive S} do {
  // sleep 10;
  private ["_pos", "_h", "_dir", "_rdir", "_pb"];
  _pos = getPosASL S;
  _h = (_pos select 2) + 3.3;
  _dir = getDir S;

  S animate ["Gun", 0];
  waitUntil {S animationPhase "Gun" < 0.1};
  sleep 5;
  // _rdir = random (2*pi);
  _rdir = random (pi);
  S animate ["Turret", _rdir];
  _dir = getDir S - (_rdir * 180) / pi;
  _pos = CIRCLEPOS2(_pos, _dir - 43, 2);
  _pos = [_pos select 0, _pos select 1, _h];
  sleep 5;

  // _missile attachTo [S, [0,0,0], "rim7_spawn1"];
  S animate ["Gun", 0.7];
  waitUntil {S animationPhase "Gun" > 0.6};
  sleep 1;
  _missile = createVehicle ["jdg_rim7", _pos, [], 0, "CAN_COLLIDE"];
  _missile setPosASL _pos;
  _missile setDir _dir;
  [_missile, 45, 0] call BIS_fnc_setPitchBank;

  sleep 5;
 };
*/
// };
